<?php

// If this file is called directly, abort.
if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

//Admin functions
class DPPEC_Admin {

	public $menu_items = array();
	

	function __construct( ) 
	{

		//Set menu items 
		$this->set_menu_items();

		add_action( 'admin_init', array($this, 'admin_scripts') );
		add_action( 'pec_enqueue_admin', array($this, 'admin_scripts') );

		add_action( 'admin_head', array($this, 'admin_head') );
		
    }

    function set_menu_items ()
    {

    	$this->menu_items[] = array( 'title' => __('General Settings','dpProEventCalendar'), 'href' => 'admin.php?page=dpProEventCalendar-settings');
    	$this->menu_items[] = array( 'title' => __('Calendars','dpProEventCalendar'), 'href' => 'admin.php?page=dpProEventCalendar-admin');
    	$this->menu_items[] = array( 'title' => __('Events','dpProEventCalendar'), 'href' => 'edit.php?post_type=pec-events');
    	$this->menu_items[] = array( 'title' => __('Venues','dpProEventCalendar'), 'href' => 'edit.php?post_type=pec-venues');
    	$this->menu_items[] = array( 'title' => __('Organizers','dpProEventCalendar'), 'href' => 'edit.php?post_type=pec-organizers');
    	$this->menu_items[] = array( 'title' => __('Speakers','dpProEventCalendar'), 'href' => 'edit.php?post_type=pec-speakers');
    	$this->menu_items[] = array( 'title' => __('Special Dates / Event Color','dpProEventCalendar'), 'href' => 'admin.php?page=dpProEventCalendar-special');
    	$this->menu_items[] = array( 'title' => __('Custom Shortcodes'), 'href' => 'admin.php?page=dpProEventCalendar-custom-shortcodes');

    	if ( is_plugin_active( 'dp-pec-payments/dp-pec-payments.php' ) ) 
    	{
    	
    		$this->menu_items[] = array( 'title' => __('Payments Options'), 'href' => 'admin.php?page=dpProEventCalendar-payments');

    	}

    	$this->menu_items[] = array( 'title' => __('Documentation'), 'href' => 'http://wpsleek.com/pro-event-calendar-documentation/');


    }

    function template_left ()
    {

    	$html = '
    	<div id="leftSide">
        	<div id="dp_logo"><h1><i class="dashicons dashicons-calendar"></i> ' . DP_PRO_EVENT_CALENDAR_TITLE . '</h1></div>
            <p>
                Version: ' . DP_PRO_EVENT_CALENDAR_VER . '<br />
            </p>
            <ul id="menu" class="nav">';

        	if(is_array($this->menu_items))
        	{
            	foreach ($this->menu_items as $key)
            	{

            		$html .= '<li>
            					<a href="' . $key['href'] . '" ' . ( strpos($_SERVER['REQUEST_URI'], $key['href']) ? 'class="active"' : '') . ' title="' . $key['title'] . '">
            						<span>' . $key['title'] . '</span>
            					</a>
            				</li>';

            	}
            }
        
        $html .= '
            </ul>

            <a href="http://codecanyon.net/downloads" target="_blank" class="rate_plugin"> ' .
                __('Rate this plugin!','dpProEventCalendar') . '
                <br>
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
                <span class="dashicons dashicons-star-filled"></span>
            </a>
            
            <div class="clear"></div>
		</div>';

		echo $html;

    }

    function show_info ( $text )
    {

    	$html = '<span class="pec_info dashicons dashicons-info"><span>' . $text . '</span></span>';

    	echo $html;

    }

    //admin settings
	function admin_scripts($force = false) 
	{
	
		global $dpProEventCalendar;

		if ( is_admin() )
		{ 

			// Settings page only

			if ( $force || (isset($_GET['page']) && 
			('dpProEventCalendar-admin' == $_GET['page'] 
			or 'dpProEventCalendar-settings' == $_GET['page'] 
			or 'dpProEventCalendar-events' == $_GET['page'] 
			or 'dpProEventCalendar-special' == $_GET['page'] 
			or 'dpProEventCalendar-import' == $_GET['page'] 
			or 'dpProEventCalendar-custom-shortcodes' == $_GET['page'] 
			or 'dpProEventCalendar-eventdata' == $_GET['page'] 
			or 'dpProEventCalendar-payments' == $_GET['page'] ))  ) {


			wp_register_script('jquery', false, false, false, false);
		
			//wp_enqueue_script( 'jquery-ui-sortable' );
			wp_enqueue_script( 'jquery-ui-datepicker'); 
			wp_enqueue_style( 'dpProEventCalendar_admin_head_css', dpProEventCalendar_plugin_url( 'css/admin-styles.css' ),
				false, DP_PRO_EVENT_CALENDAR_VER, 'all');
			wp_enqueue_style( 'jquery-ui-datepicker-style' , dpProEventCalendar_plugin_url( 'css/jquery.datepicker.min.css' ),
				false, DP_PRO_EVENT_CALENDAR_VER, 'all');
			
			wp_enqueue_script( 'dpProEventCalendar', dpProEventCalendar_plugin_url( 'js/jquery.dpProEventCalendar.js' ),
				array('jquery'), DP_PRO_EVENT_CALENDAR_VER, false); 
			wp_localize_script( 'dpProEventCalendar', 'ProEventCalendarAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ), 'postEventsNonce' => wp_create_nonce( 'ajax-get-events-nonce' ) ) );
			wp_enqueue_script( 'colorpicker2', dpProEventCalendar_plugin_url( 'js/colorpicker.js' ),
				array('jquery'), DP_PRO_EVENT_CALENDAR_VER, false); 
			wp_enqueue_script( 'selectric', dpProEventCalendar_plugin_url( 'js/jquery.selectric.min.js' ),
				array('jquery'), DP_PRO_EVENT_CALENDAR_VER, false); 
			wp_enqueue_media();
			wp_enqueue_script ( 'dpProEventCalendar_admin', dpProEventCalendar_plugin_url( 'js/admin_settings.js' ), array('jquery-ui-dialog') ); 
	    	wp_enqueue_style ('wp-jquery-ui-dialog');
			wp_enqueue_script(array('jquery', 'editor', 'thickbox', 'media-upload', 'word-count', 'post'));
			wp_enqueue_style( 'dpProEventCalendar_headcss', dpProEventCalendar_plugin_url( 'css/dpProEventCalendar.css' ),
				false, DP_PRO_EVENT_CALENDAR_VER, 'all');
			wp_enqueue_style( 'colorpicker', dpProEventCalendar_plugin_url( 'css/colorpicker.css' ),
				false, DP_PRO_EVENT_CALENDAR_VER, 'all');
			};
			
			//if(!$dpProEventCalendar['exclude_gmaps']) {
				wp_enqueue_script( 'gmaps', 'https://maps.googleapis.com/maps/api/js?v=3.exp&key='.(isset($dpProEventCalendar['google_map_key']) ? $dpProEventCalendar['google_map_key'] : ''),
					null, DP_PRO_EVENT_CALENDAR_VER, false); 
			//}
			
			wp_enqueue_style('thickbox');

	  	}

	}


	function admin_head() 
	{
	
		global $dpProEventCalendar;

		if ( is_admin() )
		{ 

		  	// Special Dates page only
			if ( isset($_GET['page']) && 'dpProEventCalendar-special' == $_GET['page'] ) 
			{
			
			?>
				<script type="text/javascript">
				// <![CDATA[
					function confirmSpecialDelete()
					{
						var agree=confirm("Delete this Special Date?");
						if (agree)
						return true ;
						else
						return false ;
					}
					
					function special_checkform ()
					{
						if (document.getElementById('dpProEventCalendar_title').value == "") {
							alert( "Please enter the title of the special date." );
							document.getElementById('dpProEventCalendar_title').focus();
							return false ;
						}
						return true ;
					}
					
					function special_checkform_edit ()
					{
						if (document.getElementById('dpPEC_special_title').value == "") {
							alert( "Please enter the title of the special date." );
							document.getElementById('dpPEC_special_title').focus();
							return false ;
						}
						return true ;
					}
					
					jQuery(document).ready(function() {
						jQuery('#specialDate_colorSelector').ColorPicker({
							onShow: function (colpkr) {
								jQuery(colpkr).fadeIn('fast');
								return false;
							},
							onHide: function (colpkr) {
								jQuery(colpkr).fadeOut('fast');
								return false;
							},
							onChange: function (hsb, hex, rgb) {
								jQuery('#specialDate_colorSelector div').css('backgroundColor', '#' + hex);
								jQuery('#dpProEventCalendar_color').val('#' + hex);
							}
						});
						
						jQuery('#specialDate_colorSelector_Edit').ColorPicker({
							onShow: function (colpkr) {
								jQuery(colpkr).fadeIn('fast');
								return false;
							},
							onHide: function (colpkr) {
								jQuery(colpkr).fadeOut('fast');
								return false;
							},
							onChange: function (hsb, hex, rgb) {
								jQuery('#specialDate_colorSelector_Edit div').css('backgroundColor', '#' + hex);
								jQuery('#dpPEC_special_color').val('#' + hex);
							}
						});
					});
				//]]>
				</script>
		<?php
		   } 
		   
		   // Calendars page only
			if ( isset($_GET['page']) && 
				('dpProEventCalendar-admin' == $_GET['page'] 
					|| 'dpProEventCalendar-payments' == $_GET['page'] 
					|| 'dpProEventCalendar-settings' == $_GET['page']
					|| 'dpProEventCalendar-custom-shortcodes' == $_GET['page']) ) {
			?>
				<script type="text/javascript">
				// <![CDATA[
					function confirmCalendarDelete()
					{
						var agree=confirm("<?php echo __("Are you sure?", "dpProEventCalendar")?>");
						if (agree)
						return true ;
						else
						return false ;
					}
					
					function confirmCalendarEventsDelete()
					{
						var agree=confirm("<?php echo __("All the events in this calendar will be deleted. Are you sure?", "dpProEventCalendar")?>");
						if (agree)
						return true ;
						else
						return false ;
					}
					
					function calendar_checkform ()
					{
						if (document.getElementById('dpProEventCalendar_title').value == "") {
							alert( "Please enter the title of the calendar." );
							document.getElementById('dpProEventCalendar_title').focus();
							return false ;
						}
						
						return true ;
					}
					
					function toggleFormat() {
						if(jQuery('#dpProEventCalendar_show_time').attr("checked")) {
							jQuery('#div_time_extended').slideDown('fast');
						} else {
							jQuery('#div_time_extended').slideUp('fast');
						}
					}
					
					function toggleTranslations() {
						if(jQuery('#dpProEventCalendar_enable_wpml').attr("checked")) {
							jQuery('#div_translations_fields').slideUp('fast');
						} else {
							jQuery('#div_translations_fields').slideDown('fast');
						}
					}
					
					function toggleNewEventRoles() {
						if(jQuery('#dpProEventCalendar_allow_user_add_event').attr("checked")) {
							jQuery('#allow_user_add_event_roles').slideDown('fast');
						} else {
							jQuery('#allow_user_add_event_roles').slideUp('fast');
						}
					}
					
					function toggleFormatCategories() {
						if(jQuery('#dpProEventCalendar_show_category_filter').attr("checked")) {
							jQuery('#div_category_filter').slideDown('fast');
						} else {
							jQuery('#div_category_filter').slideUp('fast');
						}
					}

					function toggleFormatVenues() {
						if(jQuery('#dpProEventCalendar_show_location_filter').attr("checked")) {
							jQuery('#div_venue_filter').slideDown('fast');
						} else {
							jQuery('#div_venue_filter').slideUp('fast');
						}
					}
					
					function showAccordion(div, elem) {
						if(jQuery('#'+div).css('display') == 'none') {
							jQuery('#'+div).addClass('pec_admin_accordion_show');
							jQuery(elem).addClass('dp_ui_on');
						} else {
							jQuery('#'+div).removeClass('pec_admin_accordion_show');
							jQuery(elem).removeClass('dp_ui_on');
						}
					}
					
					jQuery(document).ready(function() {
						
						var custom_uploader;


					    jQuery('#upload_image_button').click(function(e) {

					        e.preventDefault();

					        //If the uploader object has already been created, reopen the dialog
					        if (custom_uploader) {
					            custom_uploader.open();
					            return;
					        }

					        //Extend the wp.media object
					        custom_uploader = wp.media.frames.file_frame = wp.media({
					            title: '<?php esc_attr_e('Choose Image', 'dpProEventCalendar')?>',
					            button: {
					                text: '<?php esc_attr_e('Choose Image', 'dpProEventCalendar')?>'
					            },
					            multiple: true
					        });

					        //When a file is selected, grab the URL and set it as the text field's value
					        custom_uploader.on('select', function() {
					            attachment = custom_uploader.state().get('selection').first().toJSON();
					            jQuery('#dpProEventCalendar_options_map_marker').val(attachment.url);
					        });

					        //Open the uploader dialog
					        custom_uploader.open();

					    });
						
						jQuery('#currentDate_colorSelector').ColorPicker({
							onShow: function (colpkr) {
								jQuery(colpkr).fadeIn(500);
								return false;
							},
							onHide: function (colpkr) {
								jQuery(colpkr).fadeOut(500);
								return false;
							},
							onChange: function (hsb, hex, rgb) {
								jQuery('#currentDate_colorSelector div').css('backgroundColor', '#' + hex);
								jQuery('#dpProEventCalendar_current_date_color').val('#' + hex);
							}
						});

						jQuery('#bookedEvent_colorSelector').ColorPicker({
							onShow: function (colpkr) {
								jQuery(colpkr).fadeIn(500);
								return false;
							},
							onHide: function (colpkr) {
								jQuery(colpkr).fadeOut(500);
								return false;
							},
							onChange: function (hsb, hex, rgb) {
								jQuery('#bookedEvent_colorSelector div').css('backgroundColor', '#' + hex);
								jQuery('#dpProEventCalendar_booking_event_color').val('#' + hex);
							}
						});

						jQuery(".pec_calendar_shortcode, .pec_custom_shortcode").on("focus", function () {
						    jQuery(this).selectText();
						});
						jQuery(".pec_calendar_shortcode, .pec_custom_shortcode").on("click", function () {
						    jQuery(this).selectText();
						});
						
					});

					jQuery.fn.selectText = function(){
					   var doc = document;
					   var element = this[0];
					   
					   if (doc.body.createTextRange) {
					       var range = document.body.createTextRange();
					       range.moveToElementText(element);
					       range.select();
					   } else if (window.getSelection) {
					       var selection = window.getSelection();        
					       var range = document.createRange();
					       range.selectNodeContents(element);
					       selection.removeAllRanges();
					       selection.addRange(range);
					   }
					};
				//]]>
				</script>
		<?php
			}
		   // Settings page only
			if ( isset($_GET['page']) && 'dpProEventCalendar-settings' == $_GET['page'] ) {
			?>
				<script type="text/javascript">
				// <![CDATA[
					jQuery(document).ready(function() {
						jQuery('#holidays_colorSelector').ColorPicker({
							onShow: function (colpkr) {
								jQuery(colpkr).fadeIn(500);
								return false;
							},
							onHide: function (colpkr) {
								jQuery(colpkr).fadeOut(500);
								return false;
							},
							onChange: function (hsb, hex, rgb) {
								jQuery('#holidays_colorSelector div').css('backgroundColor', '#' + hex);
								jQuery('#dpProEventCalendar_holidays_color').val('#' + hex);
							}
						});
					});
				//]]>
				</script>
		<?php
		   } //Settings page only
		   
		   // Import page only
			if ( isset($_GET['page']) && 'dpProEventCalendar-import' == $_GET['page'] ) {
			?>
				<script type="text/javascript">
				// <![CDATA[
					function import_checkform ()
					{
						return true;
					}
				//]]>
				</script>
		<?php
		   } //Settings page only
		   
		 }//only for admin
	}

}

$pec_admin = new DPPEC_Admin();


?>