<?php

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


// Notification Messages for all the layouts

class DPPEC_Notifications extends DpProEventCalendar {
	

	function __construct( ) 
	{
		// Do nothing
    }

    public function message ( $type, $message, $visible = false, $extra_class = array(), $with_icon = true, $close = true )
    {

    	if(!is_array($extra_class))
    		$extra_class = array();

    	if($with_icon)
    		$extra_class[] = 'dp_pec_notification_with_icon';

    	if($visible)
    		$extra_class[] = 'dp_pec_notification_visible';

    	switch($type) 
    	{

    		case 'success':

    			$class_name = 'dp_pec_notification_event_succesfull';
    			$icon = 'fas fa-calendar-check';
    			break;

    		case 'error':

    			$class_name = 'dp_pec_notification_event_error';
    			$icon = 'fas fa-calendar-times';
    			break;

    		case 'warning':

    			$class_name = 'dp_pec_notification_event_warning';
    			$icon = 'fas fa-exclamation-circle';
    			break;

    	}

    	$html = '<div class="dp_pec_notification_event '.$class_name.' '.esc_attr(implode(" ", $extra_class)).'">';

    	if($with_icon) {

    		$html .= '<div class="dp_pec_notification_icon"><i class="'.$icon.'"></i></div>';

    	}
		
		$html .= $message;

		if($close && !$visible) {

			$html .= '<a href="#" class="dp_pec_notification_close" title=""><i class="fas fa-times-circle"></i></a>';

		}
				
		$html .= '</div>';

		return $html;


    }
	
}
?>